#import "QCPatch.h"
#import "QCOpenGLContext.h"

#import "QCNumberPort.h"
#import "QCColorPort.h"

@interface GLPointPatch : QCPatch
{
	QCNumberPort	*inputSize;
	QCNumberPort	*inputX;
	QCNumberPort	*inputY;
	QCNumberPort	*inputZ;
	QCColorPort		*inputColor;
}

+ (int)executionMode;
+ (BOOL)allowsSubpatches;
+ (int)timeMode;

- (id)initWithIdentifier:(id)fp8;
- (id)attributes;

- (id)setup:(QCOpenGLContext *)context;
- (void)cleanup:(QCOpenGLContext *)context;

- (void)enable:(QCOpenGLContext *)context;
- (void)disable:(QCOpenGLContext *)context;

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments;
@end