#import <AppKit/NSView.h>

@class GFConnection, GFGraph, GFGraphEditorView, GFList, GFNode, NSColor;

@interface GFGraphView : NSView
{
    GFGraph *_graph;
    GFNode *_firstResponder;
    BOOL _drawsBackground;
    BOOL _drawsShadows;
    unsigned int _gridStep;
    NSColor *_backgroundColor;
    NSColor *_gridColor;
    double _tooltipDelay;
    BOOL _spaceDown;
    struct _NSRect _selectionBounds;
    struct _NSPoint _connectionStart;
    struct _NSPoint _connectionEnd;
    GFConnection *_connection;
    struct __CFRunLoopTimer *_tooltipTimer;
    BOOL _tooltipPending;
    struct _NSRect _tooltipBounds;
    GFNode *_tooltipNode;
    GFList *_nodeActorCache;
    GFGraphEditorView *_graphEditor;
}

- (id)initWithFrame:(struct _NSRect)fp8;
- (void)_finalize_GFGraphView;
- (void)finalize;
- (void)dealloc;
- (BOOL)isOpaque;
- (BOOL)isFlipped;
- (BOOL)acceptsFirstMouse:(id)fp8;
- (BOOL)acceptsFirstResponder;
- (BOOL)becomeFirstResponder;
- (BOOL)resignFirstResponder;
- (void)encodeWithCoder:(id)fp8;
- (id)initWithCoder:(id)fp8;
- (BOOL)performKeyEquivalent:(id)fp8;
- (void)keyDown:(id)fp8;
- (void)keyUp:(id)fp8;
- (id)menuForEvent:(id)fp8;
- (void)mouseMoved:(id)fp8;
- (void)mouseDown:(id)fp8;
- (void)rightMouseDown:(id)fp8;
- (void)otherMouseDown:(id)fp8;
- (void)scrollWheel:(id)fp8;
- (BOOL)validateMenuItem:(id)fp8;
- (void)copy:(id)fp8;
- (void)paste:(id)fp8;
- (void)cut:(id)fp8;
- (void)duplicate:(id)fp8;
- (void)selectAll:(id)fp8;
- (unsigned int)draggingEntered:(id)fp8;
- (unsigned int)draggingUpdated:(id)fp8;
- (BOOL)performDragOperation:(id)fp8;
- (void)drawRect:(struct _NSRect)fp8;
- (struct _NSRect)adjustScroll:(struct _NSRect)fp8;
- (void)print:(id)fp8;
- (BOOL)knowsPageRange:(struct _NSRange *)fp8;
- (struct _NSRect)rectForPage:(int)fp8;
- (void)setBoundsOrigin:(struct _NSPoint)fp8;
- (void)setBoundsSize:(struct _NSSize)fp8;
@end
