@class GFGraph, GFList, NSMutableDictionary, NSString;

@interface GFNode : NSObject <NSCoding, NSCopying>
{
    GFList *_inputPorts;	// 4 = 0x4
    GFList *_outputPorts;	// 8 = 0x8
    GFGraph *_parent;	// 12 = 0xc
    unsigned int _flags;	// 16 = 0x10
    NSString *_identifier;	// 20 = 0x14
    NSMutableDictionary *_userInfo;	// 24 = 0x18
    unsigned int _notificationsDisabled;	// 28 = 0x1c
    unsigned int _notificationsPaused;	// 32 = 0x20
    GFList *_notificationsQueue;	// 36 = 0x24
    void *_unused[4];	// 40 = 0x28
}

+ (void)initialize;	// IMP=0x97ae0191
+ (id)xmlAttributesWithIdentifier:(id)fp8;	// IMP=0x97ae9228
+ (id)attributesWithIdentifier:(id)fp8;	// IMP=0x97b0c17d
+ (unsigned int)stateVersion;	// IMP=0x97b0c1c6
+ (unsigned int)stateVersionWithIdentifier:(id)fp8;	// IMP=0x97b0c1cd
+ (BOOL)createIvarPorts;	// IMP=0x97ae2ea7
+ (id)nodeWithIdentifier:(id)fp8;	// IMP=0x97ae285d
- (unsigned int)versionFromState:(id)fp8;	// IMP=0x97b0c1e4
- (id)init;	// IMP=0x97b0c235
- (void)__setValue:(id)fp8 forIvar:(const char *)fp12;	// IMP=0x97ae69a4
- (id)initWithIdentifier:(id)fp8;	// IMP=0x97ae29b1
- (void)_finalize_GFNode;	// IMP=0x97b09630
- (void)finalize;	// IMP=0x97b0c267
- (void)dealloc;	// IMP=0x97b09591
- (id)identifier;	// IMP=0x97af07af
- (id)argumentsForIvarPortWithKey:(id)fp8;	// IMP=0x97ae543e
- (id)createInputPortWithArguments:(id)fp8 forKey:(id)fp12;	// IMP=0x97ae7056
- (id)createOutputPortWithArguments:(id)fp8 forKey:(id)fp12;	// IMP=0x97ae6061
- (void)deleteInputPortForKey:(id)fp8;	// IMP=0x97aeb9c0
- (void)deleteOutputPortForKey:(id)fp8;	// IMP=0x97af025e
- (id)userInfo;	// IMP=0x97b0c2b4
- (id)inputPorts;	// IMP=0x97b0c301
- (id)outputPorts;	// IMP=0x97b0c321
- (id)ivarInputPorts;	// IMP=0x97ae95d9
- (id)ivarOutputPorts;	// IMP=0x97b0c341
- (id)customInputPorts;	// IMP=0x97aeadb9
- (id)customOutputPorts;	// IMP=0x97af2263
- (BOOL)saveCustomInputPortStates:(id)fp8 toState:(id)fp12;	// IMP=0x97b0c3ad
- (BOOL)saveCustomOutputPortStates:(id)fp8 toState:(id)fp12;	// IMP=0x97b0c464
- (BOOL)restoreCustomInputPortStates:(id)fp8 fromState:(id)fp12;	// IMP=0x97aeadf7
- (BOOL)restoreCustomOutputPortStates:(id)fp8 fromState:(id)fp12;	// IMP=0x97af0349
- (id)xmlAttributes;	// IMP=0x97aeeacb
- (id)attributes;	// IMP=0x97b0c51b
- (id)description;	// IMP=0x97b0c55d
- (id)state;	// IMP=0x97b0c65a
- (BOOL)setState:(id)fp8;	// IMP=0x97ae3dfc
- (void)encodeWithCoder:(id)fp8;	// IMP=0x97b0cee8
- (id)initWithCoder:(id)fp8;	// IMP=0x97b0d0e9
- (id)copyWithZone:(struct _NSZone *)fp8;	// IMP=0x97b0cfe2
- (id)portForKey:(id)fp8;	// IMP=0x97b08ef6
- (id)keyForPort:(id)fp8;	// IMP=0x97ae7d89
- (int)directionForPort:(id)fp8;	// IMP=0x97b0c86c
- (id)graph;	// IMP=0x97ae32c1
- (void)pauseNotifications;	// IMP=0x97ae3a80
- (void)resumeNotifications;	// IMP=0x97ae407b
- (void)stateUpdated;	// IMP=0x97ae4022
- (void)logMessage:(id)fp8;	// IMP=0x97b0c8e3
- (void)debugMessage:(id)fp8;	// IMP=0x97b0c962
- (id)key;	// IMP=0x97b0c9db
- (void)nodeDidAddToGraph:(id)fp8;	// IMP=0x97ae86dd
- (void)nodeWillRemoveFromGraph;	// IMP=0x97b09498

@end

